services:
  api:
    build:
      context: ./api
      target: api_dev
    restart: unless-stopped
    volumes:
      - ./api:/srv/app
      - php_socket:/var/run/php
      - sqlite_data:/var/data.db
    healthcheck:
      interval: 10s
      timeout: 3s
      retries: 3
      start_period: 30s
    environment:
      DATABASE_URL: 'sqlite:///var/data.db'
      TRUSTED_PROXIES: ${TRUSTED_PROXIES:-127.0.0.0/8,10.0.0.0/8,172.16.0.0/12,192.168.0.0/16}
      TRUSTED_HOSTS: ^${SERVER_NAME:-example\.com|localhost}|caddy$$
      MERCURE_URL: ${CADDY_MERCURE_URL:-http://caddy/.well-known/mercure}
      MERCURE_PUBLIC_URL: https://${SERVER_NAME:-localhost}/.well-known/mercure
      MERCURE_JWT_SECRET: ${CADDY_MERCURE_JWT_SECRET:-!ChangeThisMercureHubJWTSecretKey!}
    ports:
      - "8089:8000"

  front:
    build:
      context: ./front
      target: front_dev
    environment:
      NEXT_PUBLIC_ENTRYPOINT: http://caddy

  caddy:
    build:
      context: api/
      target: app_dev
    depends_on:
      - api
      # - pwa
      # - front
    environment:
      FRONT_UPSTREAM: front:3000
      SERVER_NAME: ${SERVER_NAME:-localhost}, caddy:80
      MERCURE_PUBLISHER_JWT_KEY: ${CADDY_MERCURE_JWT_SECRET:-!ChangeThisMercureHubJWTSecretKey!}
      MERCURE_SUBSCRIBER_JWT_KEY: ${CADDY_MERCURE_JWT_SECRET:-!ChangeThisMercureHubJWTSecretKey!}
    restart: unless-stopped
    volumes:
      - php_socket:/var/run/php
      - caddy_data:/data
      - caddy_config:/config
    ports:
      # HTTP
      - target: 80
        published: ${HTTP_PORT:-8088}
        protocol: tcp
      # HTTPS
      - target: 443
        published: ${HTTPS_PORT:-4430}
        protocol: tcp
      # HTTP/3
      - target: 443
        published: ${HTTP3_PORT:-4430}
        protocol: udp

volumes:
  php_socket:
  caddy_data:
  caddy_config:
  sqlite_data:
